Clazz.declarePackage ("JS");
Clazz.load (null, "JS.SmilesAromatic", ["JU.V3", "JS.SmilesSearch", "JU.Logger"], function () {
c$ = Clazz.declareType (JS, "SmilesAromatic");
c$.setAromatic = Clazz.defineMethod (c$, "setAromatic", 
function (n, jmolAtoms, bsSelected, vR, bsAromatic, strictness, isOpenSMILES, checkFlatness, v, nAtoms) {
var doCheck = (isOpenSMILES || strictness > 0);
for (var r = vR.size (); --r >= 0; ) {
var bs = vR.get (r);
var isOK = JS.SmilesAromatic.isFlatSp2Ring (n, jmolAtoms, bsSelected, bs, (!checkFlatness ? 3.4028235E38 : strictness > 0 ? 0.1 : 0.01), strictness == 0);
if (isOK) {
bsAromatic.or (bs);
if (doCheck && !JS.SmilesAromatic.checkOpenSmilesAromatic (n, jmolAtoms, bsAromatic, bs, strictness)) isOK = false;
}if (!isOK) bs.set (nAtoms);
}
}, "~N,~A,JU.BS,JU.Lst,JU.BS,~N,~B,~B,JS.VTemp,~N");
c$.checkAromaticDefined = Clazz.defineMethod (c$, "checkAromaticDefined", 
function (jmolAtoms, bsSelected, bsAromatic) {
for (var i = bsSelected.nextSetBit (0); i >= 0; i = bsSelected.nextSetBit (i + 1)) {
var bonds = jmolAtoms[i].getEdges ();
for (var j = 0; j < bonds.length; j++) {
switch (bonds[j].order) {
case 515:
case 514:
case 513:
bsAromatic.set (bonds[j].getAtomIndex1 ());
bsAromatic.set (bonds[j].getAtomIndex2 ());
}
}
}
}, "~A,JU.BS,JU.BS");
c$.isFlatSp2Ring = Clazz.defineMethod (c$, "isFlatSp2Ring", 
 function (n, atoms, bsSelected, bs, cutoff, allowSOxide) {
for (var i = bs.nextSetBit (0); i >= 0; i = bs.nextSetBit (i + 1)) {
var ringAtom = atoms[i];
var bonds = ringAtom.getEdges ();
if (bonds.length < 3) continue;
if (bonds.length > 3) return false;
}
if (cutoff == 3.4028235E38) return true;
if (cutoff <= 0) cutoff = 0.01;
var vTemp =  new JU.V3 ();
var vA =  new JU.V3 ();
var vB =  new JU.V3 ();
var vMean = null;
var nPoints = bs.cardinality ();
var vNorms =  new Array (nPoints * 2);
var nNorms = 0;
var maxDev = (1 - cutoff * 5);
for (var i = bs.nextSetBit (0); i >= 0; i = bs.nextSetBit (i + 1)) {
var ringAtom = atoms[i];
var bonds = ringAtom.getEdges ();
var iSub = -1;
var r1 = -1;
var r2 = -1;
for (var k = bonds.length; --k >= 0; ) {
var iAtom = ringAtom.getBondedAtomIndex (k);
if (!bsSelected.get (iAtom)) continue;
if (!bs.get (iAtom)) {
if (ringAtom.getElementNumber () == 16) {
if (!allowSOxide) return false;
iAtom = -1;
}iSub = iAtom;
} else if (r1 < 0) {
r1 = iAtom;
} else {
r2 = iAtom;
}}
if (vMean == null) vMean =  new JU.V3 ();
for (var k = 0, j = i; k < 2; k++) {
JS.SmilesSearch.getNormalThroughPoints (atoms[r1], atoms[j], atoms[r2], vTemp, vA, vB);
if (!JS.SmilesAromatic.addNormal (vTemp, vMean, maxDev)) return false;
vNorms[nNorms++] = JU.V3.newV (vTemp);
if ((j = iSub) < 0) break;
}
}
return JS.SmilesAromatic.checkStandardDeviation (vNorms, vMean, nNorms, cutoff);
}, "~N,~A,JU.BS,JU.BS,~N,~B");
c$.addNormal = Clazz.defineMethod (c$, "addNormal", 
 function (vTemp, vMean, maxDev) {
var similarity = vMean.dot (vTemp);
if (similarity != 0 && Math.abs (similarity) < maxDev) return false;
if (similarity < 0) vTemp.scale (-1);
vMean.add (vTemp);
vMean.normalize ();
return true;
}, "JU.V3,JU.V3,~N");
c$.checkStandardDeviation = Clazz.defineMethod (c$, "checkStandardDeviation", 
 function (vNorms, vMean, n, cutoff) {
var sum = 0;
var sum2 = 0;
for (var i = 0; i < n; i++) {
var v = vNorms[i].dot (vMean);
sum += v;
sum2 += (v) * v;
}
sum = Math.sqrt ((sum2 - sum * sum / n) / (n - 1));
return (sum < cutoff);
}, "~A,JU.V3,~N,~N");
c$.checkOpenSmilesAromatic = Clazz.defineMethod (c$, "checkOpenSmilesAromatic", 
 function (nAtoms, jmolAtoms, bsAromatic, bsRing, strictness) {
var npi = 0;
var n1 = 0;
for (var i = bsRing.nextSetBit (0); i >= 0 && npi >= 0; i = bsRing.nextSetBit (i + 1)) {
var atom = jmolAtoms[i];
var z = atom.getElementNumber ();
var n = atom.getCovalentBondCount () + atom.getMissingHydrogenCount () + atom.getValence () - 4;
if (z == 6) {
var fc = atom.getFormalCharge ();
if (fc != -2147483648) n += fc;
}var pt = (z >= 5 && z <= 8 ? z - 5 : z == 15 ? 2 : z == 34 ? 3 : z == 33 ? 4 : z == 16 ? 5 : -1);
if (pt >= 0) {
var a = JS.SmilesAromatic.OS_PI_COUNTS[pt];
if (n < 0 || n >= a.length) return false;
switch (n = a[n]) {
case -2:
return false;
case -1:
switch (z) {
case 6:
var bonds = atom.getEdges ();
n = 0;
for (var j = bonds.length; --j >= 0; ) {
var b = bonds[j];
if (b.getCovalentOrder () != 2) continue;
var het = b.getOtherAtomNode (atom);
n = (het.getElementNumber () == 6 || bsAromatic.get (het.getIndex ()) ? 1 : strictness > 0 ? -100 : 0);
break;
}
break;
case 7:
var nbonds = atom.getEdges ();
n = -100;
if (strictness == 0) for (var j = nbonds.length; --j >= 0; ) {
var b = nbonds[j];
if (b.getCovalentOrder () != 2) continue;
var other = b.getOtherAtomNode (atom);
if (bsAromatic.get (other.getIndex ())) continue;
n = (other.getElementNumber () == 6 ? 2 : 1);
break;
}
break;
default:
return false;
}
default:
npi += n;
if (n == 1) n1++;
if (JU.Logger.debugging) JU.Logger.debug ("atom " + atom + " pi=" + n + " npi=" + npi);
continue;
}
}}
return (npi > 0 && (npi - 2) % 4 == 0 && (strictness < 2 || nAtoms == 5 || n1 == 6));
}, "~N,~A,JU.BS,JU.BS,~N");
c$.finalizeAromatic = Clazz.defineMethod (c$, "finalizeAromatic", 
function (jmolAtoms, bsAromatic, lstAromatic, isOpenSmiles, doTrim) {
bsAromatic.clearAll ();
for (var i = lstAromatic.size (); --i >= 0; ) bsAromatic.or (lstAromatic.get (i));

if (!doTrim) return;
for (var i = bsAromatic.nextSetBit (0); i >= 0; i = bsAromatic.nextSetBit (i + 1)) {
var bonds = jmolAtoms[i].getEdges ();
var naro = 0;
for (var j = bonds.length; --j >= 0; ) {
var otherAtom = bonds[j].getOtherAtomNode (jmolAtoms[i]);
var isJAro = bsAromatic.get (otherAtom.getIndex ());
if (isJAro) {
naro++;
} else if (!isOpenSmiles && otherAtom.getElementNumber () == 6 && bonds[j].getCovalentOrder () == 2) {
naro = -1;
break;
}}
if (naro < 2) {
bsAromatic.clear (i);
i = -1;
}}
}, "~A,JU.BS,JU.Lst,~B,~B");
Clazz.defineStatics (c$,
"OS_PI_COUNTS",  Clazz.newArray (-1, [ Clazz.newIntArray (-1, [-2, 1, 0]),  Clazz.newIntArray (-1, [1, 2, 1, -1]),  Clazz.newIntArray (-1, [2, 1, 2, 1, -1]),  Clazz.newIntArray (-1, [2, 1]),  Clazz.newIntArray (-1, [-2, 1, 2, 1, -2]),  Clazz.newIntArray (-1, [2, 1, 2, 2])]));
});
